package edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.visitorpattern.*;
import java.util.Vector;
import java.lang.reflect.Array;

/**
 * Implementation for the interface For.
 * The FOR is for XML Algebra. Op1[FOR(CB)[Op2[Correlated Operator[A],B]]] -->
 * Op1[Groupby(CB, Op2[])[Operator[Cartesian[A,B]]]] 
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0    
 */
public class FORImp extends ColumnNameListImp implements FOR {
    protected XATTree xtreFunctions;

   /**
    * Assign a node to this operator .
    * @param xnodInit edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
    * @since   1.0        
    */
    public FORImp(XATNode xnodInit) {
        super(xnodInit);
        xtreFunctions = null;
        vColNames = new Vector();
    }
   /**
    * Assign a node to and a tree this operator .
    * @param xnodInit is the node
    * @param xtreFuncInit is the tree
    * @since   1.0       
    */
    public FORImp(XATNode xnodInit, XATTree xtreFuncInit) {
        super(xnodInit);
        xtreFunctions = xtreFuncInit;
        vColNames = new Vector();
    }
   /** 
    * Used to implement a visitor pattern. 
    * @param visitor for the visitor pattern
    * @since   1.0       
    */
    public void accept(Visitor visitor) {
    }
   /**
    * Gets inner data source.
    * @return inner data source.
    * @since   1.0        
    */
    public XATTable getInnerSource() {
        return null;
    }
   /**
    * Gets outer data source. It should be same as the getPrimarySource.
    * @return outer data source.
    * @since   1.0       
    */
    public XATTable getOuterSource() {
        return null;
    }
   /**
    * Get the tree for the FOR node.
    * @return the XAT tree.
    * @since   1.0       
    */
    public XATTree getXtreFunctions() {
        return xtreFunctions;
    }
   /**
    * Sets the tree for the FOR node.
    * @param xat is the For node tree.
    * @since   1.0       
    */
    public void setXtreFunctions(XATTree xat) {
        xtreFunctions = xat;
    }
   /**
    * returns a string representation 
    * @return java.lang.String
    * @since   1.0       
    */
    public String toString() {
        StringBuffer result = new StringBuffer();
        String[] binding = this.getColumnNames();
        result.append("FOR[binding: " + binding[0] + "]:" + this.getOutputColumnName());
        return result.toString();
    }
}
