package edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator;
/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import edu.wpi.cs.dsrg.xmldb.xat.common.visitorpattern.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.*;

/**
 * Implementation for the NavUnnest interface. 
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0   
 */
public class NavUnnestImp extends NavigateImp implements NavUnnest {

    /**
     * Assigns a node to this operator.
     * @param xnodInit edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
     * @since   1.0   
     */
    public NavUnnestImp(XATNode xnodInit) {
        super(xnodInit);
    }

    /**
     * Assigns a node to this operator, an entry point, and a destination .
     * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
     * @param ep edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavigationStep[]
     * @param d edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavigationStep[]
     * @since   1.0   
     */
    public NavUnnestImp(XATNode node, NavigationStep[] ep, NavigationStep[] d) {
        super(node, ep, d);
    }

    /**
     * Returns a String that represents the value of this object.
     * @return a String representation of the object
     * @since   1.0          
     */
    public String toString() {
        StringBuffer result = new StringBuffer();
        result.append(
            "NavUnnest: "
                + getOutputColumnName()
                + " := "
                + toXPath(entry)
                + "->"
                + toXPath(dest));
        return result.toString();
    }
}