package edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

/**
 * Implementation for the NavigationStep interface. 
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0   
 */
public abstract class NavigationStepImp implements NavigationStep {
    String stepValue;

    /**
     * No param constructor, assigns null as the step.
     * @since   1.0   
     */
    public NavigationStepImp() {
        stepValue = null;
    }
    /**
    * Assigns a step value .
    * @param newvalue String
    * @since   1.0   
    */
    public NavigationStepImp(String newvalue) {
        stepValue = newvalue;
    }
    /**
    * Gets step value .
    * @return String
    * @since   1.0   
    */
    public String getStepValue() {
        return stepValue;
    }
    /**
    * Sets a step value .
    * @param newvalue String
    * @since   1.0   
    */
    public void setStepValue(String newvalue) {
        stepValue = newvalue;
    }
    /**
     * Returns a String that represents the value of this object.
     * @return a String representation of the object
     * @since   1.0          
     */
    public String toString() {
        return this.getStepValue();
    }
}
