package edu.wpi.cs.dsrg.xmldb.xat.testfiles;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import java.io.*;
import xacute.quilt.*;
import edu.wpi.cs.dsrg.utils.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.xattreegeneration.*;

/**
 * This Class is used to test XATTree generation.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0
 */


public class TreeGenerationTest
{

public static void main(String args[]) throws Exception {
    String query = null;

    //reads a query from a file and translates it
    //into a string
    query = readQuery(args[0]);
    QuiltParser parser = new QuiltParser();
    QuiltQuery q = null;

    try {
        q = parser.parseQuery(query);
            ParserTraverse pt = new ParserTraverse();
            pt.visit(q);
            //used for printing
            Debugger debug = new Debugger(pt.getTree());
            debug.printTree();
            QueryDecorrelation qd = new QueryDecorrelation(pt.getTree());
            Debugger debugqd = new Debugger(qd.getDecorTree());
            debugqd.printTree();
    } catch (Exception e) {
        e.printStackTrace(System.out);
        System.exit(-1);
    }

    System.exit(0);

}
    /**
     * Reads in the contents of a file and converts it to a string object
     */
    private static String readQuery(String file)
	throws Exception
    {
	BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(file)));
	StringBuffer buf = new StringBuffer();
	String s;
	while ( (s=in.readLine()) != null)
	    buf.append(s + "\n");
        in.close();
	return buf.toString();
    }
}
